package Box2D.Dynamics.Joints
{
   import Box2D.Common.Math.b2Vec2;
   import Box2D.Dynamics.b2Body;
   
   public class b2PrismaticJointDef extends b2JointDef
   {
       
      
      public var motorSpeed:Number;
      
      public var localAxis1:b2Vec2;
      
      public var referenceAngle:Number;
      
      public var upperTranslation:Number;
      
      public var localAnchor1:b2Vec2;
      
      public var localAnchor2:b2Vec2;
      
      public var enableLimit:Boolean;
      
      public var enableMotor:Boolean;
      
      public var maxMotorForce:Number;
      
      public var lowerTranslation:Number;
      
      public function b2PrismaticJointDef()
      {
         localAnchor1 = new b2Vec2();
         localAnchor2 = new b2Vec2();
         localAxis1 = new b2Vec2();
         super();
         type = b2Joint.e_prismaticJoint;
         localAxis1.Set(1,0);
         referenceAngle = 0;
         enableLimit = false;
         lowerTranslation = 0;
         upperTranslation = 0;
         enableMotor = false;
         maxMotorForce = 0;
         motorSpeed = 0;
      }
      
      public function Initialize(b1:b2Body, b2:b2Body, anchor:b2Vec2, axis:b2Vec2) : void
      {
         body1 = b1;
         body2 = b2;
         localAnchor1 = body1.GetLocalPoint(anchor);
         localAnchor2 = body2.GetLocalPoint(anchor);
         localAxis1 = body1.GetLocalVector(axis);
         referenceAngle = body2.GetAngle() - body1.GetAngle();
      }
   }
}
