package core
{
   import Box2D.Collision.b2ContactPoint;
   import Box2D.Dynamics.Contacts.b2ContactEdge;
   import Box2D.Dynamics.Contacts.b2ContactResult;
   import Box2D.Dynamics.b2Body;
   import Box2D.Dynamics.b2ContactListener;
   import core.events.CoreEvent;
   import flash.events.EventDispatcher;
   
   public class BContactListener extends b2ContactListener
   {
      
      public static const COLLIDE_ADD:String = "CollideAdd";
      
      public static const COLLIDE_PERSIST:String = "CollidePersist";
      
      public static const COLLIDE_REMOVE:String = "CollideRemove";
      
      public static const COLLIDE_RESULT:String = "CollideResult";
       
      
      public var dispatcher:EventDispatcher;
      
      public function BContactListener()
      {
         super();
         dispatcher = new EventDispatcher();
      }
      
      override public function Add(point:b2ContactPoint) : void
      {
         dispatcher.dispatchEvent(new CoreEvent(COLLIDE_ADD,point));
      }
      
      override public function Persist(point:b2ContactPoint) : void
      {
         dispatcher.dispatchEvent(new CoreEvent(COLLIDE_PERSIST,point));
      }
      
      public function collideExist(body1:b2Body, body2:b2Body) : Boolean
      {
         var c:b2ContactEdge = body1.m_contactList;
         while(c)
         {
            if(c.other == body2)
            {
               return true;
            }
            c = c.next;
         }
         return false;
      }
      
      override public function Remove(point:b2ContactPoint) : void
      {
         dispatcher.dispatchEvent(new CoreEvent(COLLIDE_REMOVE,point));
      }
      
      override public function Result(point:b2ContactResult) : void
      {
         dispatcher.dispatchEvent(new CoreEvent(COLLIDE_RESULT,point));
      }
   }
}
