package game.controller
{
   import game.model.AppProxy;
   import game.model.NotesProxy;
   import game.view.AppMediator;
   import game.view.MainMenuMediator;
   import game.view.components.AppView;
   import game.view.components.MainMenuView;
   import org.puremvc.as3.interfaces.ICommand;
   import org.puremvc.as3.interfaces.INotification;
   import org.puremvc.as3.patterns.command.SimpleCommand;
   
   public class InitializeCommand extends SimpleCommand implements ICommand
   {
       
      
      public function InitializeCommand()
      {
         super();
      }
      
      override public function execute(note:INotification) : void
      {
         var appView:AppView = new AppView();
         ApplicationFacade.getInstance().viewContainer.addChild(appView);
         var appMed:AppMediator = new AppMediator(appView);
         facade.registerMediator(appMed);
         var notesProxy:NotesProxy = facade.retrieveProxy(NotesProxy.NAME) as NotesProxy;
         notesProxy.push(AppProxy.SCORES_INIT);
         var mainMenuView:MainMenuView = new MainMenuView();
         appMed.getViewContainer().addChild(mainMenuView);
         var mainMenuMed:MainMenuMediator = new MainMenuMediator(mainMenuView);
         facade.registerMediator(mainMenuMed);
      }
   }
}
