package game.controller
{
   import core.CoreEngine;
   import game.model.GameProxy;
   import game.view.AppMediator;
   import game.view.EndGameMediator;
   import game.view.GameMediator;
   import game.view.MainMenuMediator;
   import game.view.components.MainMenuView;
   import org.puremvc.as3.interfaces.ICommand;
   import org.puremvc.as3.interfaces.INotification;
   import org.puremvc.as3.patterns.command.SimpleCommand;
   
   public class QuitGameCommand extends SimpleCommand implements ICommand
   {
       
      
      public function QuitGameCommand()
      {
         super();
      }
      
      override public function execute(note:INotification) : void
      {
         CoreEngine.getInstance().destroy();
         var gameMed:GameMediator = facade.retrieveMediator(GameMediator.NAME) as GameMediator;
         gameMed.destroy();
         facade.removeProxy(GameProxy.NAME);
         var endGameMed:EndGameMediator = facade.retrieveMediator(EndGameMediator.NAME) as EndGameMediator;
         if(endGameMed)
         {
            endGameMed.destroy();
         }
         var appMed:AppMediator = facade.retrieveMediator(AppMediator.NAME) as AppMediator;
         appMed.stopMusic();
         var mainMenuView:MainMenuView = new MainMenuView();
         appMed.getViewContainer().addChild(mainMenuView);
         var mainMenuMed:MainMenuMediator = new MainMenuMediator(mainMenuView);
         facade.registerMediator(mainMenuMed);
      }
   }
}
