package game.view
{
   import caurina.transitions.Tweener;
   import core.bonuses.AbstractBonus;
   import game.model.GameProxy;
   import game.view.components.BonusIconView;
   import org.puremvc.as3.interfaces.IMediator;
   import org.puremvc.as3.interfaces.INotification;
   import org.puremvc.as3.patterns.mediator.Mediator;
   
   public class BonusIconMediator extends Mediator implements IMediator
   {
       
      
      private var NAME:String;
      
      private var _view:BonusIconView;
      
      private var bonus:AbstractBonus;
      
      public function BonusIconMediator(NAME:String, viewComponent:BonusIconView)
      {
         this.NAME = NAME;
         super(NAME,viewComponent);
         init();
      }
      
      override public function listNotificationInterests() : Array
      {
         return [GameProxy.UPDATE,GameProxy.BONUS_COLLECT,GameProxy.BONUS_ACTIVATE,GameProxy.BONUS_DEACTIVATE];
      }
      
      override public function handleNotification(note:INotification) : void
      {
         var b:AbstractBonus = null;
         switch(note.getName())
         {
            case GameProxy.UPDATE:
               update();
               break;
            case GameProxy.BONUS_COLLECT:
               b = note.getBody() as AbstractBonus;
               if(b == bonus)
               {
                  bonusCollect();
               }
               break;
            case GameProxy.BONUS_ACTIVATE:
               b = note.getBody() as AbstractBonus;
               if(b == bonus)
               {
                  bonusActivate();
               }
               break;
            case GameProxy.BONUS_DEACTIVATE:
               b = note.getBody() as AbstractBonus;
               if(b == bonus)
               {
                  bonusDeactivate();
               }
         }
      }
      
      private function update() : void
      {
         if(bonus.timeLeft > 0)
         {
            _view.time_tf.text = bonus.timeLeft.toString();
         }
      }
      
      private function bonusCollect() : void
      {
         _view.num_tf.text = bonus.num.toString();
      }
      
      private function init() : void
      {
         _view = getViewComponent() as BonusIconView;
      }
      
      private function bonusActivate() : void
      {
         _view.num_tf.text = bonus.isGood ? bonus.num.toString() : "";
         Tweener.addTween(_view.inner,{
            "alpha":1,
            "scaleX":1.2,
            "scaleY":1.2,
            "time":0.5,
            "transition":"easeoutback"
         });
      }
      
      public function initialize(bonus:AbstractBonus) : void
      {
         this.bonus = bonus;
         _view.num_tf.text = bonus.isGood ? bonus.num.toString() : "";
         _view.time_tf.text = "";
      }
      
      private function bonusDeactivate() : void
      {
         _view.time_tf.text = "";
         Tweener.addTween(_view.inner,{
            "alpha":0.5,
            "scaleX":1,
            "scaleY":1,
            "time":0.5,
            "transition":"easeoutback"
         });
      }
   }
}
