package game.view
{
   import caurina.transitions.Tweener;
   import core.CoreEngine;
   import flash.events.MouseEvent;
   import flash.media.Sound;
   import flash.media.SoundChannel;
   import game.model.AppProxy;
   import game.model.GameProxy;
   import game.model.NotesProxy;
   import game.view.components.EndGameView;
   import org.puremvc.as3.interfaces.IMediator;
   import org.puremvc.as3.interfaces.INotification;
   import org.puremvc.as3.patterns.mediator.Mediator;
   
   public class EndGameMediator extends Mediator implements IMediator
   {
      
      public static const NAME:String = "EndGameMediator";
       
      
      private var _view:EndGameView;
      
      private var sndEndGame:Sound;
      
      private var playerName:String;
      
      private var sndChannel:SoundChannel;
      
      private var playerPoints:int;
      
      public function EndGameMediator(viewComponent:EndGameView)
      {
         super(NAME,viewComponent);
         init();
      }
      
      override public function listNotificationInterests() : Array
      {
         return [];
      }
      
      public function destroy() : void
      {
         _view.parent.removeChild(_view);
         facade.removeMediator(NAME);
      }
      
      override public function handleNotification(note:INotification) : void
      {
      }
      
      private function destroyPrevGame() : void
      {
         CoreEngine.getInstance().destroy();
         var gameMed:GameMediator = facade.retrieveMediator(GameMediator.NAME) as GameMediator;
         gameMed.destroy();
         facade.removeProxy(GameProxy.NAME);
      }
      
      private function sendClickHandler(e:MouseEvent) : void
      {
         playerName = _view.name_tf.text;
         var appProxy:AppProxy = facade.retrieveProxy(AppProxy.NAME) as AppProxy;
         appProxy.playerName = game.§view:EndGameMediator§.playerName;
         var scoresMed:ScoresMediator = facade.retrieveMediator(ScoresMediator.NAME) as ScoresMediator;
         scoresMed.sendScores(playerPoints,game.§view:EndGameMediator§.playerName);
         _view.send_bt.visible = false;
      }
      
      private function init() : void
      {
         _view = getViewComponent() as EndGameView;
         var appProxy:AppProxy = facade.retrieveProxy(AppProxy.NAME) as AppProxy;
         playerName = appProxy.playerName;
         _view.name_tf.text = game.§view:EndGameMediator§.playerName;
         _view.stage.focus = _view.name_tf;
         _view.name_tf.setSelection(_view.name_tf.length,_view.name_tf.length);
         _view.restart_bt.addEventListener(MouseEvent.CLICK,restartClickHandler);
         _view.alpha = 0;
         Tweener.addTween(_view,{
            "alpha":1,
            "time":0.5,
            "transition":"linear"
         });
      }
      
      private function restartClickHandler(e:MouseEvent) : void
      {
         destroyPrevGame();
         var notesProxy:NotesProxy = facade.retrieveProxy(NotesProxy.NAME) as NotesProxy;
         notesProxy.push(AppProxy.START_GAME);
         destroy();
      }
      
      public function initialize(status:uint) : void
      {
         if(status == 0)
         {
            _view.title_tf.text = "Oops...";
         }
         else if(status == 1)
         {
            _view.title_tf.text = "Game Complete! Well done.";
         }
         var gameProxy:GameProxy = facade.retrieveProxy(GameProxy.NAME) as GameProxy;
         _view.points_tf.text = gameProxy.getScore().toString();
         _view.level_tf.text = gameProxy.getLevelNum().toString();
         playerPoints = gameProxy.getScore();
         _view.send_bt.addEventListener(MouseEvent.CLICK,sendClickHandler);
         if(Preloader.SPONSOR_VERSION)
         {
            _view.nameHolder.visible = false;
            _view.send_bt.visible = false;
         }
      }
   }
}
