package game.view
{
   import caurina.transitions.Tweener;
   import flash.display.MovieClip;
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import game.model.AppProxy;
   import game.model.GameAssets;
   import game.model.NotesProxy;
   import game.view.components.GameView;
   import game.view.components.InstructionsView;
   import org.puremvc.as3.interfaces.IMediator;
   import org.puremvc.as3.interfaces.INotification;
   import org.puremvc.as3.patterns.mediator.Mediator;
   
   public class InstructionsMediator extends Mediator implements IMediator
   {
      
      public static const NAME:String = "InstructionsMediator";
       
      
      private var platformAppear:MovieClip;
      
      private var _view:InstructionsView;
      
      private var gameIcons:Array;
      
      private var gameView:GameView;
      
      public function InstructionsMediator(viewComponent:InstructionsView)
      {
         super(NAME,viewComponent);
         init();
      }
      
      override public function handleNotification(note:INotification) : void
      {
      }
      
      override public function listNotificationInterests() : Array
      {
         return [];
      }
      
      private function appearUI() : void
      {
         var icon:Sprite = null;
         var alpha:Number = NaN;
         Tweener.addTween(gameView.menuFrame,{
            "alpha":1,
            "time":1.3,
            "transition":"linear",
            "onComplete":appearComplete
         });
         for(var i:uint = 0; i < gameIcons.length; i++)
         {
            icon = gameIcons[i];
            icon.alpha = 0;
            alpha = 0.5;
            if(i > 5)
            {
               alpha = 1;
            }
            Tweener.addTween(icon,{
               "alpha":alpha,
               "time":0.5,
               "delay":i * 0.1,
               "transition":"linear"
            });
         }
      }
      
      private function goClickHandler(e:MouseEvent) : void
      {
         var appMed:AppMediator = facade.retrieveMediator(AppMediator.NAME) as AppMediator;
         var appProxy:AppProxy = facade.retrieveProxy(AppProxy.NAME) as AppProxy;
         appMed.startMusic();
         gameView = new GameView();
         appMed.getViewContainer().addChild(gameView);
         if(appProxy.soundEnabled)
         {
            gameView.soundIcon.gotoAndStop(1);
         }
         else
         {
            gameView.soundIcon.gotoAndStop(2);
         }
         if(appProxy.musicEnabled)
         {
            gameView.musicIcon.gotoAndStop(1);
         }
         else
         {
            gameView.musicIcon.gotoAndStop(2);
         }
         if(Preloader.SPONSOR_VERSION)
         {
            gameView.sponsorLogo_bt.visible = false;
         }
         gameView.platformBasis.visible = false;
         var PlatformAppearClass:Class = GameAssets.getInstance().getAssetClass("PlatformBasisAppear");
         platformAppear = new PlatformAppearClass();
         platformAppear.x = gameView.platformBasis.x;
         platformAppear.y = gameView.platformBasis.y;
         gameView.objectsContainer.addChild(platformAppear);
         platformAppear.addEventListener(Event.ENTER_FRAME,platformEfHandler);
         gameView.menuFrame.alpha = 0;
         gameIcons = [gameView.powerupIcon,gameView.pushFieldIcon,gameView.attachIcon,gameView.elasticIcon,gameView.freezeIcon,gameView.inverseIcon,gameView.menuIcon,gameView.soundIcon,gameView.musicIcon];
         for(var i:uint = 0; i < gameIcons.length; i++)
         {
            gameIcons[i].alpha = 0;
         }
         gameView.time.visible = false;
         gameView.levelView.visible = false;
         gameView.fps.visible = false;
         gameView.sponsorLogo_bt.alpha = 0;
         Tweener.addTween(gameView.sponsorLogo_bt,{
            "alpha":1,
            "time":0.5,
            "transition":"linear"
         });
         gameView.pause.visible = false;
      }
      
      private function appearComplete() : void
      {
         gameView.parent.removeChild(gameView);
         var notesProxy:NotesProxy = facade.retrieveProxy(NotesProxy.NAME) as NotesProxy;
         notesProxy.push(AppProxy.INSTRUCTIONS_HIDE);
         destroy();
      }
      
      private function platformEfHandler(e:Event) : void
      {
         if(platformAppear.currentFrame == platformAppear.totalFrames)
         {
            platformAppear.stop();
            platformAppear.removeEventListener(Event.ENTER_FRAME,platformEfHandler);
            appearUI();
         }
      }
      
      private function destroy() : void
      {
         _view.parent.removeChild(_view);
         facade.removeMediator(NAME);
      }
      
      private function init() : void
      {
         _view = getViewComponent() as InstructionsView;
         _view.go_bt.addEventListener(MouseEvent.CLICK,goClickHandler);
      }
   }
}
