package game.view
{
   import caurina.transitions.Tweener;
   import flash.display.SimpleButton;
   import flash.events.MouseEvent;
   import flash.net.URLRequest;
   import flash.net.navigateToURL;
   import game.model.AppProxy;
   import game.model.NotesProxy;
   import game.view.components.MainMenuView;
   import org.puremvc.as3.interfaces.IMediator;
   import org.puremvc.as3.interfaces.INotification;
   import org.puremvc.as3.patterns.mediator.Mediator;
   
   public class MainMenuMediator extends Mediator implements IMediator
   {
      
      public static const NAME:String = "MainMenuMediator";
       
      
      private var buttons:Array;
      
      private var _view:MainMenuView;
      
      public function MainMenuMediator(viewComponent:MainMenuView)
      {
         super(NAME,viewComponent);
         init();
      }
      
      override public function listNotificationInterests() : Array
      {
         return [];
      }
      
      private function highscoresClickHandler(e:MouseEvent) : void
      {
         var scoresMed:ScoresMediator = facade.retrieveMediator(ScoresMediator.NAME) as ScoresMediator;
         scoresMed.showScores();
      }
      
      private function sponsorLogoClickHandler(e:MouseEvent) : void
      {
         navigateToURL(new URLRequest("http://www.ourworld.com/v11/tracking?source=game&id=fglbeez"),"_blank");
      }
      
      private function soundsnapClickHandler(e:MouseEvent) : void
      {
         navigateToURL(new URLRequest("http://soundsnap.com"),"_blank");
      }
      
      override public function handleNotification(note:INotification) : void
      {
      }
      
      private function karataevClickHandler(e:MouseEvent) : void
      {
         navigateToURL(new URLRequest("mailto:island@ngs.ru"),"_blank");
      }
      
      private function moreGamesClickHandler(e:MouseEvent) : void
      {
         navigateToURL(new URLRequest("http://www.ourworld.com/v11/tracking?source=game&id=fglbeez"),"_blank");
      }
      
      private function init() : void
      {
         var bt:SimpleButton = null;
         var btY:Number = NaN;
         _view = getViewComponent() as MainMenuView;
         _view.startGame_bt.addEventListener(MouseEvent.CLICK,startGameClickHandler);
         _view.highscores_bt.addEventListener(MouseEvent.CLICK,highscoresClickHandler);
         _view.moreGames_bt.addEventListener(MouseEvent.CLICK,moreGamesClickHandler);
         _view.karataev_bt.addEventListener(MouseEvent.CLICK,karataevClickHandler);
         _view.box2d_bt.addEventListener(MouseEvent.CLICK,box2dClickHandler);
         _view.soundsnap_bt.addEventListener(MouseEvent.CLICK,soundsnapClickHandler);
         _view.title.alpha = 0;
         Tweener.addTween(_view.title,{
            "alpha":1,
            "time":0.5,
            "delay":0.3,
            "transition":"linear"
         });
         _view.credits.alpha = 0;
         Tweener.addTween(_view.credits,{
            "alpha":1,
            "time":0.5,
            "delay":1,
            "transition":"linear"
         });
         if(Preloader.SPONSOR_VERSION)
         {
            _view.karataev_bt.visible = false;
            _view.box2d_bt.visible = false;
            _view.soundsnap_bt.visible = false;
            _view.sponsorLogo_bt.mouseEnabled = false;
            _view.startGame_bt.x = 325;
            _view.highscores_bt.visible = false;
            _view.moreGames_bt.visible = false;
            buttons = [_view.startGame_bt];
         }
         else
         {
            _view.sponsorLogo_bt.addEventListener(MouseEvent.CLICK,sponsorLogoClickHandler);
            buttons = [_view.startGame_bt,_view.highscores_bt,_view.moreGames_bt];
         }
         for(var i:uint = 0; i < buttons.length; i++)
         {
            bt = buttons[i];
            btY = bt.y;
            bt.y = 540;
            Tweener.addTween(bt,{
               "y":btY,
               "time":0.8,
               "transition":"easeoutback",
               "delay":i * 0.2
            });
         }
      }
      
      private function startGameClickHandler(e:MouseEvent) : void
      {
         var bt:SimpleButton = null;
         _view.startGame_bt.removeEventListener(MouseEvent.CLICK,startGameClickHandler);
         _view.highscores_bt.removeEventListener(MouseEvent.CLICK,highscoresClickHandler);
         _view.moreGames_bt.removeEventListener(MouseEvent.CLICK,moreGamesClickHandler);
         Tweener.addTween(_view.title,{
            "alpha":0,
            "time":0.5,
            "delay":0.3,
            "transition":"linear"
         });
         Tweener.addTween(_view.credits,{
            "alpha":0,
            "time":0.5,
            "delay":1,
            "transition":"linear",
            "onComplete":dissapearComplete
         });
         for(var i:uint = 0; i < buttons.length; i++)
         {
            bt = buttons[i];
            Tweener.addTween(bt,{
               "y":540,
               "time":0.8,
               "transition":"easeinback",
               "delay":i * 0.2
            });
         }
      }
      
      private function destroy() : void
      {
         _view.parent.removeChild(_view);
         facade.removeMediator(NAME);
      }
      
      private function dissapearComplete() : void
      {
         var notesProxy:NotesProxy = facade.retrieveProxy(NotesProxy.NAME) as NotesProxy;
         notesProxy.push(AppProxy.INSTRUCTIONS_SHOW);
         destroy();
      }
      
      private function box2dClickHandler(e:MouseEvent) : void
      {
         navigateToURL(new URLRequest("http://box2d.org"),"_blank");
      }
   }
}
