package game.view
{
   import flash.events.MouseEvent;
   import game.view.components.ScoresView;
   import mochi.MochiScores;
   import mochi.MochiServices;
   import org.puremvc.as3.interfaces.IMediator;
   import org.puremvc.as3.interfaces.INotification;
   import org.puremvc.as3.patterns.mediator.Mediator;
   
   public class ScoresMediator extends Mediator implements IMediator
   {
      
      public static const NAME:String = "ScoresMediator";
       
      
      private var _view:ScoresView;
      
      public function ScoresMediator(viewComponent:ScoresView)
      {
         super(NAME,viewComponent);
         init();
      }
      
      private function scoresShowErrorHandler() : void
      {
         trace("error loading leaderboard!");
      }
      
      private function hide() : void
      {
         _view.visible = false;
      }
      
      override public function listNotificationInterests() : Array
      {
         return [];
      }
      
      public function sendScores(playerScore:int, playerName:String) : void
      {
         show();
         var options:Object = {
            "score":playerScore,
            "name":playerName,
            "onClose":mochiCloseHandler,
            "onError":scoresShowErrorHandler,
            "res":"640x480"
         };
         MochiScores.showLeaderboard(options);
      }
      
      private function mochiErrorHandler(txt:String) : void
      {
         _view.status.visible = true;
         _view.status_tf.text = "Не удается соединиться с сервером: " + txt;
      }
      
      private function statusOkClickHandler(e:MouseEvent) : void
      {
         _view.status.visible = false;
         hide();
      }
      
      private function mochiCloseHandler() : void
      {
         hide();
      }
      
      private function init() : void
      {
         _view = getViewComponent() as ScoresView;
         var boardID:String = "e03be5c4150d50e6";
         var gameID:String = "61d9f17a5618b630";
         MochiServices.onError = mochiErrorHandler;
         MochiServices.connect(gameID,_view.mochiContainer,mochiErrorHandler);
         MochiScores.setBoardID(boardID);
         _view.status.visible = false;
         _view.statusOk_bt.addEventListener(MouseEvent.CLICK,statusOkClickHandler);
         hide();
      }
      
      override public function handleNotification(note:INotification) : void
      {
      }
      
      private function show() : void
      {
         _view.visible = true;
      }
      
      public function showScores() : void
      {
         show();
         var options:Object = {
            "onClose":mochiCloseHandler,
            "onError":scoresShowErrorHandler,
            "res":"640x480"
         };
         MochiScores.showLeaderboard(options);
      }
   }
}
